SystemOrganization addCategory: #SyncRepo!

Object subclass: #RepoAndFiles
	instanceVariableNames: 'repo files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!RepoAndFiles methodsFor: 'operations' stamp: 'hjo 4/27/2012 19:42'!
copyFilesTo: subo2

	(self files copyWithoutAll: subo2 files) do: [:each| |version| 
		version := self repo loadVersionFromFileNamed: each. 
		version isNil
			ifTrue: [Transcript cr; nextPutAll: '#loadVersionFromFileNamed: failed. The argument was '; print: each; flush]
			ifFalse: [subo2 repo storeVersion: version]
		 ].! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
files
	^ files! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
files: anObject
	files := anObject! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
repo
	^ repo! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
repo: anObject
	repo := anObject! !

!RepoAndFiles methodsFor: 'operations' stamp: 'hjo 4/21/2012 03:34'!
updateAllFiles

	files := repo allFileNames asSet.! !

!RepoAndFiles methodsFor: 'operations' stamp: 'hjo 4/21/2012 03:43'!
updateFilesOfPackageNames: packageNames

	files := (repo allFileNames select: [:each|  packageNames anySatisfy: [:str | each beginsWith: str,'-']  ]) asSet.! !

Object subclass: #SyncRepo
	instanceVariableNames: 'packageNames repos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/21/2012 03:37'!
repository: repo1 repository: repo2 

	^self new 
		repo1: repo1;
		repo2: repo2;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/15/2012 10:57'!
repository: repo1 repository: repo2 packageNames: anArray

	^self new 
		repo1: repo1;
		repo2: repo2;
		packageNames: anArray;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/15/2012 10:57'!
repository: repo1 repository: repo2 stringOfPackageNames: aString

	^self new 
		repo1: repo1;
		repo2: repo2;
		packageNames: aString subStrings;
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/21/2012 03:53'!
shareAll

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade2'))! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/25/2012 21:44'!
shareAni

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCHttpRepository location: 'http://www.squeaksource.com/DaliotsPlayground' user: '' password: '') 
		stringOfPackageNames: 'LazyRabbit LazyRabbitOmniBrowser Daliot SortDescriptors Ani ConfigurationOfDaliotsPlayground'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/27/2012 19:18'!
shareDevPacer

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/DevPacer')) stringOfPackageNames: 'Ani AniOmniBrowser Daliot LazyRabbit LazyRabbitOmniBrowser DevPacer DevPacerPharo12 DevPacerPharo13 DevPacerPharo14'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/21/2012 02:50'!
shareMe

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCHttpRepository location: 'http://ss3.gemstone.com/ss/SyncRepo' user: 'hjo' password: '') stringOfPackageNames: 'SyncRepo'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/23/2012 00:03'!
shareSourceCodeTourGuide

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/SourceCodeTourGuide')) stringOfPackageNames: 
		'Ani Daliot DrillDownMethodSearch LazyRabbit SortDescriptors SourceCodeTourGuide SourceCodeTourGuideOmniBrowser SourceCodeTourGuidePharo12 SourceCodeTourGuidePharo13 SourceCodeTourGuidePharo14'.! !

!SyncRepo methodsFor: 'initialize-release' stamp: 'hjo 4/27/2012 19:27'!
initialize

	super initialize.
	repos := Array new: 2.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:56'!
packageNames: strings

	packageNames := strings.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/27/2012 19:35'!
repo1: anMCRepository
	repos at: 1 put: RepoAndFiles new.
	(repos at: 1) repo: anMCRepository! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/27/2012 19:36'!
repo2: anMCRepository
	repos at: 2 put: RepoAndFiles new.
	(repos at: 2) repo: anMCRepository! !

!SyncRepo methodsFor: 'operation' stamp: 'hjo 4/27/2012 19:41'!
syncRepos
	| update |
	update := packageNames isNil
		ifTrue: [ MessageSend receiver: nil selector: #updateAllFiles ]
		ifFalse: [ MessageSend receiver: nil selector: #updateFilesOfPackageNames: argument: packageNames ].
	repos
		do: [ :each | 
			update receiver: each.
			update value ].
	(repos at: 1) copyFilesTo: (repos at: 2).
	(repos at: 2) copyFilesTo: (repos at: 1).! !
